<template>
  <div class="something-wrong-dialog">
    <el-dialog
      v-model="isSomethingWentWrong"
      :show-close="false"
      :width="isMobile ? '90%' : '30%'"
      align-center
      :close-on-press-escape="false"
      :close-on-click-modal="false"
    >
      <template #title>
        <div
          class="flex justify-center gap-2 something-wrong-title ol-bg-light"
        >
          <span class="font-medium" :class="isMobile ? 'text-xl' : 'text-2xl'"
            >{{ $t("error") }} !!</span
          >
        </div>
      </template>
      <div class="flex flex-col items-center gap-2">
        <div
          class="font-black"
          style="word-break: break-word"
          :class="isMobile ? 'text-xl' : 'text-[24px]'"
        >
          {{ errorMessage }} ({{ traceId }})
        </div>
      </div>
      <template #footer>
        <a
          href="#"
          class="fc-primary uppercase flex justify-center font-bold something-wrong-footer"
          :class="isMobile ? 'text-base' : 'text-2xl'"
          @click.prevent="onCLickClose"
          >{{ $t("close") }}</a
        >
      </template>
    </el-dialog>
  </div>
</template>

<script lang="ts" setup>
import { IResult, ISpinState } from "~~/models/lucky-wheel/luckyWheel";

type propsType = {
  reward: IResult;
  spinState: ISpinState;
  somethingWentWrong: boolean;
  errorMessage: string;
  dialogVisible: boolean;
  traceId: number;
};

const props = defineProps<propsType>();
const emits = defineEmits([
  "update:spinState",
  "update:somethingWentWrong",
  "update:dialogVisible",
]);
const spinningState = ref(props.spinState);
const isSomethingWentWrong = ref(props.somethingWentWrong);
const onCLickClose = () => {
  spinningState.value = {
    isDefault: true,
    isSpinning: false,
    isStoppedSpin: false,
    settled: false,
  };
  isSomethingWentWrong.value = false;
  emits("update:spinState", spinningState.value);
  emits("update:somethingWentWrong", isSomethingWentWrong.value);
  emits("update:dialogVisible", isSomethingWentWrong.value);
};
const isMobile = !useIsDesktop();
</script>

<style lang="scss">
.something-wrong-dialog {
  .el-dialog {
    background: var(--background5) !important;
    outline: unset;
    margin-top: auto;
    margin-bottom: auto;
    border-radius: 16px;

    .el-dialog__header {
      margin-right: 0;
      padding: 0;
    }
    .el-dialog__footer {
      margin-right: 0;
      padding: 0;
    }
  }
  .something-wrong-title {
    padding-top: 14px;
    padding-bottom: 14px;
    border-bottom: 1px solid var(--border);
    border-top-left-radius: 16px;
    border-top-right-radius: 16px;
    --bg-opacity: 0.05;
    --bg-base-color: var(--background5);
  }
  .something-wrong-footer {
    padding-top: 14px;
    padding-bottom: 14px;
    border-top: 1px solid var(--border);
  }
}
</style>
